"use strict";
{

	C3.Behaviors.aekiro_gameobject.Instance = class MyBehaviorInstance extends C3.SDKBehaviorInstanceBase {
		constructor(behInst, properties)
		{
			super(behInst);
	
			//properties
			if (properties){
				this.name = properties[0];
				this.parentName = properties[1];
				this.parentSameLayer = properties[2];
			}
	
			//********************
			var self = this;
			this.GetObjectInstance().GetUnsavedDataMap().aekiro_gameobject = this;
			this.inst = this.GetObjectInstance();
			this.wi = this.GetWorldInfo();
			this.acts = this.GetObjectInstance().GetPlugin().constructor.Acts;
			this.eventManager = new EventManager(this.inst);
			this.goManager = window["aekiro_goManager"];
			/*this.eventManager.on("childrenAdded",function(){
				console.log("onChildrenAdded " + self.GetObjectInstance().GetUID());
			});*/
			
			this.userName = this.name?this.name:null;
			this.areChildrenRegistred = false;
			this.children = [];
			this.parent = null;
			this.local = {
				x : this.wi.GetX(),
				y : this.wi.GetY(),
				angle: this.wi.GetAngle(),
				_sinA: Math.sin(this.wi.GetAngle()),
				_cosA: Math.cos(this.wi.GetAngle())
			};
			this.overrideBuiltin = true;
			this.updateHierarchy = true;
			
			this.overrideWorldInfo();
			this.goManager.init(this.GetRuntime(),this.GetBehaviorType().GetBehavior());
			this.goManager.addGO(this.inst);
			
			this.prev = {
				x : this.wi.GetX(),
				y : this.wi.GetY(),
				angle : this.wi.GetAngle(),
				width: this.wi.GetWidth(),
				height: this.wi.GetHeight()
			};
			
	
			/*this.list = this.goManager.eventManager.on("childrenRegistred",function(){
				console.log("event childrenRegistred ********* ");
			},{"once":true});*/
			
	
			
			//console.log("constructor gameobject");
		}
	
	
		PostCreate(){
			//console.log("PostCreate gameobject");
		}
		
		overrideWorldInfo(){
			if(this.isWorldInfoOverrided)return;
			this.isWorldInfoOverrided = true;
			
			var inst = this.GetObjectInstance();
			var wi = inst.GetWorldInfo();
			
			wi.SetX_old = wi.SetX;
			wi.SetX = function (x,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent){
					var y = this.GetY("g");
					
					if(!isGlobal){ //local
						aekiro_gameobject.local.x = x;
						x = aekiro_gameobject.localToGlobal_x();
						y = aekiro_gameobject.localToGlobal_y();
					}
					this.SetXY_old(x,y);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
					
				}else{
					this.SetX_old(x);
				}
				aekiro_gameobject.children_update();
			};
			
			wi.SetY_old = wi.SetY;
			wi.SetY = function (y,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent){
					var x = this.GetX("g");
					if(!isGlobal){//local
						aekiro_gameobject.local.y = y;
						x = aekiro_gameobject.localToGlobal_x();
						y = aekiro_gameobject.localToGlobal_y();	
					}
					this.SetXY_old(x,y);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
				}else{
					this.SetY_old(y);
				}
				aekiro_gameobject.children_update();
			};
			
			wi.SetXY_old = wi.SetXY;
			wi.SetXY = function (x,y,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent){
					if(!isGlobal){ //local
						aekiro_gameobject.local.x = x;
						aekiro_gameobject.local.y = y;
						x = aekiro_gameobject.localToGlobal_x();
						y = aekiro_gameobject.localToGlobal_y();
					}
					this.SetXY_old(x,y);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
				}else{
					this.SetXY_old(x,y);
				}
	
				aekiro_gameobject.children_update();
			};
			
			
			wi.OffsetX_old = wi.OffsetX;
			wi.OffsetX = function (_x,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent){
					var x = this.GetX("g");
					var y = this.GetY("g");
					if(!isGlobal){ //local
						aekiro_gameobject.local.x += _x;
						x = aekiro_gameobject.localToGlobal_x();
						y = aekiro_gameobject.localToGlobal_y();
					}else{
						x += _x;
					}
					this.SetXY_old(x,y);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
				}else{
					this.OffsetX_old(_x);
				}
	
				aekiro_gameobject.children_update();
				
			};
			
			wi.OffsetY_old = wi.OffsetY;
			wi.OffsetY = function (_y,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				
				if(aekiro_gameobject.parent){
					var x = this.GetX("g");
					var y = this.GetY("g");
					if(!isGlobal){ //local
						aekiro_gameobject.local.y += _y;
						x = aekiro_gameobject.localToGlobal_x();
						y = aekiro_gameobject.localToGlobal_y();
					}else{
						y += _y;
					}
					this.SetXY_old(x,y);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
				}else{
					this.OffsetY_old(_y);
				}
	
				aekiro_gameobject.children_update();
				
			};
			
			wi.OffsetXY_old = wi.OffsetXY;
			wi.OffsetXY = function (_x,_y,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				
				if(aekiro_gameobject.parent){
					var x = this.GetX("g");
					var y = this.GetY("g");
					if(!isGlobal){ //local
						aekiro_gameobject.local.x += _x;
						aekiro_gameobject.local.y += _y;
						x = aekiro_gameobject.localToGlobal_x();
						y = aekiro_gameobject.localToGlobal_y();
					}else{
						x += _x;
						y += _y;
					}
					this.SetXY_old(x,y);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
				}else{
					this.OffsetXY_old(_x,_y);
				}
	
				aekiro_gameobject.children_update();
			};
			
			
			wi.SetAngle_old = wi.SetAngle;
			wi.SetAngle = function (angle,isGlobal){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent){
					if(!isGlobal){ //local
						aekiro_gameobject.local.angle = angle;
						aekiro_gameobject.local._sinA = Math.sin(angle);
						aekiro_gameobject.local._cosA = Math.cos(angle);
						angle = aekiro_gameobject.localToGlobal_angle();
					}
					this.SetAngle_old(angle);
					if(isGlobal){
						aekiro_gameobject.updateLocals();
					}
				}else{
					this.SetAngle_old(angle);
				}
	
				aekiro_gameobject.children_update();
			};
			
			
			wi.GetX_old = wi.GetX;
			wi.GetX = function (space){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent && !space){
					return aekiro_gameobject.local.x;
				}
				return this.GetX_old();
			};
			
			wi.GetY_old = wi.GetY;
			wi.GetY = function (space){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent && !space){
					return aekiro_gameobject.local.y;
				}
				return this.GetY_old();
			};
			
			wi.GetAngle_old = wi.GetAngle;
			wi.GetAngle = function (space){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent && !space){
					return aekiro_gameobject.local.angle;
				}
				return this.GetAngle_old();
			};
			
			
			wi.GetCosAngle_old = wi.GetCosAngle;
			wi.GetCosAngle = function (space){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent && !space){
					return aekiro_gameobject.local._cosA;
				}
				return this.GetCosAngle_old();
			};
			
			
			wi.GetSinAngle_old = wi.GetSinAngle;
			wi.GetSinAngle = function (space){
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parent && !space){
					return aekiro_gameobject.local._sinA;
				}
				return this.GetSinAngle_old();
			};
			
			wi.SetWidth_old = wi.SetWidth;
			wi.SetWidth = function (v,onlyNode){
				if(onlyNode)this.SetWidth_old(v);
				
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				
				/*if(!aekiro_gameobject.areChildrenRegistred)
					aekiro_gameobject.children_register();*/
	
				v = v==0?0.1:v;
				var f = v/this.GetWidth();
	
				this.SetWidth_old(v);
				var h = aekiro_gameobject.children;
				for (var i = 0, l= h.length; i < l; i++) {
					wi = h[i].GetWorldInfo();
					wi.SetWidth(wi.GetWidth()*f);
					wi.SetX(wi.GetX()*f);
					wi.SetBboxChanged();
				}
			};
			
			wi.SetHeight_old = wi.SetHeight;
			wi.SetHeight = function (v,onlyNode){
				if(onlyNode)this.SetHeight_old(v);
				
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				
				/*if(!aekiro_gameobject.areChildrenRegistred)
					aekiro_gameobject.children_register();*/
	
				v = v==0?0.1:v;
				var f = v/this.GetHeight();
	
				this.SetHeight_old(v);
				var h = aekiro_gameobject.children;
				for (var i = 0, l= h.length; i < l; i++) {
					wi = h[i].GetWorldInfo();
					wi.SetHeight(wi.GetHeight()*f);
					wi.SetY(wi.GetY()*f);
					wi.SetBboxChanged();
				}
			};
	
			wi.SetSize_old = wi.SetSize;
			wi.SetSize = function (w,h,onlyNode){
				if(onlyNode)this.SetSize_old(w,h);
				
				var inst = this.GetInstance();
				var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				
				/*if(!aekiro_gameobject.areChildrenRegistred)
					aekiro_gameobject.children_register();*/
	
				w = w==0?0.1:w;
				h = h==0?0.1:h;
				var fw = h/this.GetHeight();
				var fh = w/this.GetWidth();
	
				this.SetSize_old(w,h);
				var c = aekiro_gameobject.children;
				for (var i = 0, l= c.length; i < l; i++) {
					wi = c[i].GetWorldInfo();
					wi.SetSize(wi.GetWidth()*fw,wi.GetHeight()*fh);
					wi.SetX(wi.GetX()*fw);
					wi.SetY(wi.GetY()*fh);
					wi.SetBboxChanged();
				}
			};
			
		}
		
		//**********************************************
		
		children_update(){
			if(!this.children.length){
				return;
			}
			var inst,wi,l = this.children.length;
			for (var i = 0; i < l; i++) {
				inst = this.children[i];
				wi = inst.GetWorldInfo();
	
				//updating the child's global coordinates when the parent global coordinates changes.
				wi.SetXY(wi.GetX(),wi.GetY());
				wi.SetAngle(wi.GetAngle());
				wi.SetBboxChanged();
			}
		}
	
		children_add(inst){
			var name,aekiro_gameobject;
			if (typeof inst === 'string'){ //add by child name
				name = inst;
				inst = null;
			}else{
				aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(!aekiro_gameobject){
					console.error("Aekiro GameObject: You're adding a child (uid=%s) without a gameobject behavior on it.",inst.GetUID());
					return;
				}
				name = aekiro_gameobject.name;
			}
	
			//check if gameobject is correctly registred in the gomanager
			inst = this.goManager.gos[name];
			
			if(inst == this.GetObjectInstance()){ //can't add itself
				return;
			}
			
			if(!inst){
				console.error("Aekiro GameObject: Object of name : %s not found !",name);
				return;
			}
			if(name == this.parentName){
				console.error("Aekiro GameObject: Cannot add %s as a child of %s, because %s is its parent !",name,this.name,name);
				return;
			}
			if(this.children.indexOf(inst) > -1){
				console.error("Aekiro GameObject: Object %s already have a child named %s !",this.name,name);
				return;
			}
	
			aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
			aekiro_gameobject.removeFromParent(); //if inst is already a child of another parent then remove it from its parent.
			aekiro_gameobject.parentName = this.name;
			aekiro_gameobject.parent = this.GetObjectInstance();
	
			var res = this.globalToLocal(inst,this.GetObjectInstance());		
			aekiro_gameobject.local.x = res.x;
			aekiro_gameobject.local.y = res.y
			aekiro_gameobject.local.angle = res.angle;
			this.children.push(inst);
			
			this.eventManager.emit("childrenAdded",{"args":inst,"propagate":false});
		}
		
		
		updateLocals(){
			var parent = this.parent_get();
			var res = this.globalToLocal(this.GetObjectInstance(),parent);		
			this.local.x = res.x;
			this.local.y = res.y
			this.local.angle = res.angle;
		}
		
		children_addFromLayer (layer){
			var insts = layer._instances;
			var myInst = this.GetObjectInstance();
			var inst,aekiro_gameobject;
			for (var i = 0, l = insts.length; i < l; i++) {
				inst = insts[i];
				aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
				if(inst != myInst && aekiro_gameobject && aekiro_gameobject.parentName==""){
					this.children_add(inst);
				}
			}
		}
		
		children_addFromType (type){
			var insts = type.GetCurrentSol().GetInstances();
			for (var i = 0, l = insts.length; i < l; i++) {
				this.children_add(insts[i]);
			}		
		}
		
		children_remove(inst){
			var index = -1;
			if (typeof inst === 'string'){ //remove by child name
				for (var i = 0, l= this.children.length; i < l; i++) {
					if(this.children[i].GetUnsavedDataMap().aekiro_gameobject.name==inst){
						index = i;
						break;
					}
				}
			}else{
				index = this.children.indexOf(inst);
			}
	
			if(index!=-1){
				var aekiro_gameobject = this.children[index].GetUnsavedDataMap().aekiro_gameobject;
				aekiro_gameobject.parentName = "";
				aekiro_gameobject.parent = null;
				this.children.splice(index, 1);
				
			}
		}
		
		children_removeFromType (type){
			var insts = type.GetCurrentSol().GetInstances();
			for (var i = 0, l = insts.length; i < l; i++) {
				this.children_remove(insts[i]);
			}		
		}
		
		removeAllChildren(){
			if(!this.children.length)
				return;
			
			var aekiro_gameobject;
			var l = this.children.length;
			for (var i = 0; i < l; i++) {
				aekiro_gameobject = this.children[i].GetUnsavedDataMap().aekiro_gameobject;
				aekiro_gameobject.parentName = "";
				aekiro_gameobject.parent = null;
			}
			this.children.length = 0;
		}
		
		//**********************************************
	
		removeFromParent(){
			//var parent = this.parent_get();
			var parent = this.parent;
			var inst = this.GetObjectInstance();
			if(parent){
				var aekiro_gameobject = parent.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject){
					aekiro_gameobject.children_remove(inst);
				}
					
			}
		}
		
		destroyHierarchy(){
			var runtime = this.GetRuntime();
			
			runtime.DestroyInstance(this.GetObjectInstance());
			for (var i = 0, l= this.children.length; i < l; i++) {
				this.children[i].GetUnsavedDataMap().aekiro_gameobject.destroyHierarchy()
			}
			this.children.length = 0;
		}
		
		parent_get(){
			if(!this.parent && this.parentName && this.name){
				this.parent = this.goManager.gos[this.parentName];	
			}
			return this.parent;
		}
		
		getTemplate(node){
			if(!node){
				node = this._inst;
			}
			
			var template = {
				type: node.GetObjectClass(),
				x: node.GetWorldInfo().GetX(),
				y: node.GetWorldInfo().GetY(),
				zindex:node.GetWorldInfo().GetZIndex()+node.GetWorldInfo().GetLayer().GetIndex()*100,
				json:JSON.stringify(node.SaveToJson(!0)),
				children:[]
			};
			
	
			var children = node.GetUnsavedDataMap().aekiro_gameobject.children;
			for (var i = 0, l= children.length; i < l; i++) {
				template.children.push(this.getTemplate(children[i]));
			}
	
			return template;
		}
	
		hierarchyToArray(node,ar){
			if(!node){
				node = this.GetObjectInstance();
			}
	
			if(!ar){
				ar = [];
			}
	
			ar.push(node);
	
			var children = node.GetUnsavedDataMap().aekiro_gameobject.children;
			for (var i = 0, l= children.length; i < l; i++) {
				this.hierarchyToArray(children[i],ar);
			}
	
			return ar;
		}
	
		updateZindex(){
			var children = this.hierarchyToArray();
			
			children.sort(function(a, b) {
				return a.GetUnsavedDataMap().zindex - b.GetUnsavedDataMap().zindex;
			});
	
			var layer = children[0].GetWorldInfo().GetLayer();
			//layer.moveInstanceAdjacent(children[0], children[children.length-1], true);
			for (var i = 1, l= children.length; i < l; i++) {
				layer.MoveInstanceAdjacent(children[i], children[i-1], true);
			}
			this.GetRuntime().UpdateRender();
		}
		
		setTimeScale(s){
			var children = this.hierarchyToArray();
			
			for (var i = 1, l= children.length; i < l; i++) {
				children[i].SetTimeScale(s);
			}
		}
		
		
	
		Tick(){
		}
	
		Release2(){
			this.goManager.removeGO(this.name);
			this.removeFromParent();
			
			//this is necesserary when a parent have global children that still keep a reference to the parent.
			//when changing layout this reference need to be deleted
			for (var i = 0, l= this.children.length; i < l; i++) {
				this.children_remove(this.children[i]);
			}
			
			super.Release();
		}
		
		SaveToJson(){
			return {
			};
		}
	
		LoadFromJson(o){			
		}
	
		GetDebuggerProperties(){		
			var children = [];
			for (var i = 0,l=this.children.length; i < l; i++) {
				children.push(this.children[i].GetUnsavedDataMap().aekiro_gameobject.name);
			}
			var children_str = JSON.stringify(children,null,"\t");
	
			/*var objects = [];
			Object.keys(this.goManager.gos).forEach(function(key) {
				objects.push(key);
			});
			var objects_str = JSON.stringify(objects,null,"\t");*/
	
			return [{
				title: "aekiro_gameobject",
				properties: [
					{name: "name", value: this.name},
					{name: "parentName", value: this.parentName},
					{name: "children", value: children_str},
					{name: "local_x", value: this.local.x},
					{name: "local_y",value: this.local.y},
					{name: "local_angle",value: this.local.angle}
					//{name: "gameobjects", value: objects_str}
				]
			}];
		}
		
		//**********************************************
		
		applyActionToHierarchy(action,v){
			this.GetObjectInstance().GetSdkInstance().CallAction(action,v);
			var h = this.children;
			for (var i = 0, l= h.length; i < l; i++) {
				h[i].GetUnsavedDataMap().aekiro_gameobject.applyActionToHierarchy(action,v);
			}
		}
		
		SetBlendMode(bm){
			this.wi.SetBlendMode(bm);
			var h = this.children;
			for (var i = 0, l= h.length; i < l; i++) {
				h[i].GetWorldInfo().SetBlendMode(bm);
			}
			
		}
		//**********************************************		
		//transform global coordinates of inst to local coordinates in parent space
		globalToLocal(inst,parent_inst){
			var wip = parent_inst.GetWorldInfo();
			return this.globalToLocal2(inst,wip.GetX("g"),wip.GetY("g"),wip.GetAngle("g"));
		}
		
		globalToLocal2(inst,p_x,p_y,p_angle){
			var res = {};
			var wi = inst.GetWorldInfo();
			res.x = (wi.GetX("g")-p_x)*Math.cos(p_angle) + (wi.GetY("g")-p_y)*Math.sin(p_angle);
			res.y = -(wi.GetX("g")-p_x)*Math.sin(p_angle) + (wi.GetY("g")-p_y)*Math.cos(p_angle);
			res.angle = wi.GetAngle("g") - p_angle;
			return res;
		}
	
		//transform local coordinates of inst in parent space to global coordinates
		localToGlobal(inst,p_x,p_y,p_angle){
			var res = {};
			var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
			res.x = p_x + aekiro_gameobject.local.x*Math.cos(p_angle) - aekiro_gameobject.local.y*Math.sin(p_angle);
			res.y = p_y + aekiro_gameobject.local.x*Math.sin(p_angle) + aekiro_gameobject.local.y*Math.cos(p_angle);
			res.angle = p_angle + aekiro_gameobject.local.angle;
			return res;
		}
	
		localToGlobal_x(){
			var parent = this.parent_get();
			if(parent){
				//console.log(this.GetObjectInstance().GetUID());
				var wp = parent.GetWorldInfo();
				var x = wp.GetX("g") + this.local.x*Math.cos(wp.GetAngle("g")) - this.local.y*Math.sin(wp.GetAngle("g"));
				return x;
			}else{
				return this.local.x;
			}
		}
	
		localToGlobal_y(){
			var parent = this.parent_get();
			if(parent){
				var wp = parent.GetWorldInfo();
				var y = wp.GetY("g") + this.local.x*Math.sin(wp.GetAngle("g")) + this.local.y*Math.cos(wp.GetAngle("g"));
				return y;
			}else{
				return this.local.y;
			}
		}
		
		localToGlobal_angle(){
			var parent = this.parent_get();
			if(parent){
				var wp = parent.GetWorldInfo();
				var angle = wp.GetAngle("g") + this.local.angle;
				return angle;
			}else{
				return this.local.angle;
			}
		}
		
	};

}



if(!aekiro_goManager){
	var aekiro_goManager = {
		gos : {},
		haltNext:false,
		isRegistering:false,
		eventManager: new EventManager(),
		lastLayout:0,
		
		init : function(runtime,beh){
			if(this.runtime)return;
			
			this.runtime = runtime;		
			//this is used instead of Release(), because Release() comes after beforelayoutstart and clears everything that was setup.
			this.runtime.Dispatcher().addEventListener("instancedestroy", function(e){
				//if(!runtime.GetLayoutManager().IsEndingLayout())return;
				var go = e.instance.GetUnsavedDataMap().aekiro_gameobject;
				if(go){
					//go.goManager.eventManager.removeListener(go.list);
					go.Release2();	
				}
			});
			
			var layouts = this.runtime.GetLayoutManager().GetAllLayouts();
			var l = layouts.length ;
			for (var i = 0; i < l; i++) {
				layouts[i]._iLayout.addEventListener("beforelayoutstart",() =>{
					this.register();
				});
			}
			
		},
	
		clean : function(){
			var key;
			for(key in this.gos){
				if(this.gos[key].IsDestroyed()){
					this.removeGO(key);
				}
			}
		},
		
		clean2 : function(){
			var key;
			for(key in this.gos){
				if(!this.gos[key].GetObjectClass().IsGlobal()){
					this.removeGO(key);
					//remove from its parent's children list
					//this.removeFromParent();
	
					/*var runtime = this.GetRuntime();
					for (var i = 0, l= this.children.length; i < l; i++) {
						runtime.DestroyInstance(this.children[i]);
					}
					this.children.length = 0;*/
				}
			}
		},
		
		addGO : function(inst){
			if(this.haltNext)return;
			if(!inst)return;
			
			var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
	
			if(!aekiro_gameobject.name){
				aekiro_gameobject.name = "o"+inst.GetUID();
			}
			/*if(!name){
				console.error("Aekiro Hierarchy: object of uid=%s has no name !",inst.uid);
				return;
			}*/
			var name = aekiro_gameobject.name;
			if(this.gos.hasOwnProperty(name)){
				console.error("Aekiro Hierarchy: GameObject already exist with name: %s !",name);
				return;
			}
	
			this.gos[name] = inst;
		},
	
		removeGO : function(name){
			delete this.gos[name];
		},
	
		createInstance : function (objectClass,layer,x,y){
			var inst = this.runtime.CreateInstance(objectClass,layer,x,y);
			const b = this.runtime.GetEventSheetManager();
			b.BlockFlushingInstances(!0);
			//inst._TriggerOnCreated();
			b.BlockFlushingInstances(!1);
			//
			/*if(!noSOLChange){
				objectClass.GetCurrentSol().SetSinglePicked(inst);
			}*/
				
			return inst;
		},
		
		clone : function (template,name,parent,layer, x, y,onNodeCreated){
			if(this.gos[name]){
				console.error("Aekiro GameObject: GameObject already exist with name: %s !",name);
				return;
			}
			
			if (typeof parent === 'string'){
				parent = this.gos[parent];	
			}
			
			//the x,y are global and _clone expect locals, so transform xy into locals in parent space
			if(parent){
				var wp = parent.GetWorldInfo();
				var res = this.globalToLocal3(x,y,0,wp.GetX("g"),wp.GetY("g"),wp.GetAngle("g"));
				x = res.x;
				y = res.y;
			}
			
			var inst = this._clone(template,name,parent,layer,x,y,onNodeCreated);
			
			inst.GetUnsavedDataMap().aekiro_gameobject.children_update();
			inst.GetUnsavedDataMap().aekiro_gameobject.updateZindex();
			
			var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
			aekiro_gameobject.eventManager.emit("cloned");
			
			return inst;
		},
		
		_clone : function (t_node,name,parent,layer, x, y, onNodeCreated){
			//haltNext is used to skip addGo() executed on the instance creation
			this.haltNext = true;
			var inst = this.createInstance(t_node.type, layer);
			this.haltNext = false;
	
			var b;
			try {
				b = JSON.parse(t_node.json);
			} catch (a) {
				return void console.error("Failed to load from JSON string: ", a);
			}
			inst.LoadFromJson(b,!0);
			
			
			
			var aekiro_gameobject = inst.GetUnsavedDataMap().aekiro_gameobject;
			//aekiro_gameobject.eventManager.emit("cloned");
			
			inst.GetUnsavedDataMap().zindex = t_node.zindex;
			inst.GetSdkInstance().CallAction(aekiro_gameobject.acts.MoveToLayer,layer);
	
			
			aekiro_gameobject.name = "";
			if(name)aekiro_gameobject.name = name;
			this.addGO(inst);
			//aekiro_gameobject.onCreateInit();
			
			if(parent){
				parent.GetUnsavedDataMap().aekiro_gameobject.children_add(inst);
			}
			
			var wi = inst.GetWorldInfo();
			wi.SetX(x);
			wi.SetY(y);
			wi.SetBboxChanged();
			
			if(onNodeCreated)onNodeCreated(inst);
			
			//we put the trigger after the json state is applied, so that any modif happening in the eventsheet onCreated wont be overrided by the LoadFromJsonString
			inst._TriggerOnCreated();
			
			
			var child;
			for (var i = 0, l= t_node.children.length; i < l; i++) {
				child = t_node.children[i];
				this._clone(child,null,inst, layer, child.x, child.y,onNodeCreated);
			}
	
			return inst;
		},
		
		globalToLocal3: function(x,y,a,p_x,p_y,p_angle){
			var res = {};
			res.x = (x-p_x)*Math.cos(p_angle) + (y-p_y)*Math.sin(p_angle);
			res.y = -(x-p_x)*Math.sin(p_angle) + (y-p_y)*Math.cos(p_angle);
			res.angle = a - p_angle;
			return res;
		},
		
		register:function(){
			/*if(this.isRegistering)return;	
			this.isRegistering = true;*/
			//console.log(this.gos);
			var key, go, aekiro_gameobject;
			var parentSameLayer = {};
			for(key in this.gos){
				go = this.gos[key];
				aekiro_gameobject = go.GetUnsavedDataMap().aekiro_gameobject;
				if(aekiro_gameobject.parentName && this.gos[aekiro_gameobject.parentName]){
					this.gos[aekiro_gameobject.parentName].GetUnsavedDataMap().aekiro_gameobject.children_add(go);
				}
				if(aekiro_gameobject.parentSameLayer){
					parentSameLayer[key] = go;
				}
			}
			
			for(key in parentSameLayer){
				go = parentSameLayer[key];
				aekiro_gameobject = go.GetUnsavedDataMap().aekiro_gameobject;
				aekiro_gameobject.children_addFromLayer(aekiro_gameobject.GetWorldInfo().GetLayer());
			}
			
			//the onCreated trigger is executed before the children_register; so when a modif is applied to the parent on the trigger, the chidlren dont get updated
			for(key in this.gos){
				this.gos[key].GetUnsavedDataMap().aekiro_gameobject.children_update();
			}
			
			//console.log("childrenRegistred");
			this.eventManager.emit("childrenRegistred");
		}
	
	};
}


function EventManager(inst){
	this.map = {};
	this.inst = inst;
}

EventManager.prototype.constructor = EventManager;

EventManager.prototype.on = function (eventName,callback,options) {
	if(!this.map[eventName]){
		this.map[eventName] = [];
	}
	
	var once = false;
	if(options){
		once = options.once;
	}
	
	var listener = {"callback":callback,"once":once, "eventName": eventName}
	this.map[eventName].push(listener);
	
	return listener;
};

EventManager.prototype.emit = function (eventName,options) {
	options = options || {};
	var listeners = this.map[eventName];
	var listener;
	if(listeners){
		for (var i = 0, l=listeners.length; i < l; i++) {
			listener = listeners[i];
			listener["callback"](options.args);
			if(listener["once"]){
				this.removeListener(listener);
				
				l=listeners.length;
				i--;
			}
		}
		
	}
	
	
	if(options.propagate == undefined) options.propagate = true;
	if(options.bubble == undefined) options.bubble = true;
	
	var options2 = Object.assign({}, options);
	options2.propagate = false;
	//bubble the event up the hierarchy
	if(options.bubble === true && this.inst){
		var go = this.inst.GetUnsavedDataMap().aekiro_gameobject;
		if(go.parent){
			go.parent.GetUnsavedDataMap().aekiro_gameobject.eventManager.emit(eventName,options2);
		}	
	}
	
	options2 = Object.assign({}, options);
	options2.bubble = false;
	//propagate the event down the hierarchy 
	
	if(options.propagate === true && this.inst){
		var go = this.inst.GetUnsavedDataMap().aekiro_gameobject;
		var children = go.children;
		for (var i = 0, l=children.length; i < l; i++) {
			children[i].GetUnsavedDataMap().aekiro_gameobject.eventManager.emit(eventName,options);
		}
	}
};

EventManager.prototype.removeListener = function (listener) {
	var listeners = this.map[listener["eventName"]];
	var index = listeners.indexOf(listener);
	listeners.splice(index, 1);
};
